#include <stdio.h>
#include <sql.h>
#include <sqlext.h>
#include <ltdl.h>

int main( int argc, char *argv[] )
{
	void	*hini, *hdm;
	SQLRETURN	(*pae)(SQLSMALLINT,SQLHANDLE,SQLHANDLE*);
    SQLRETURN   (*sea)(SQLHANDLE,SQLINTEGER,SQLPOINTER,SQLINTEGER,SQLINTEGER);
	char	*pError;
    char    str[ 64 ];
    SQLRETURN ret;
    SQLHANDLE env, dbc;

    hini = lt_dlopen( "libodbcinst.so" );
    hdm = lt_dlopen( "libodbc.so" );

	if ( !hini || !hdm )
	{
		printf( "No\n" );
		exit( 1 );
	}

    /*
     * extract SQLAllocHandle(); 
     */

    pae = lt_dlsym( hdm, "SQLAllocHandle" );
    if ( !pae )
    {
		printf( "No\n" );
		exit( 2 );
    }

    sea = lt_dlsym( hdm, "SQLSetEnvAttr" );
    if ( !sea )
    {
		printf( "No\n" );
		exit( 3 );
    }

    ret = pae( SQL_HANDLE_ENV, SQL_NULL_HANDLE, &env );
    if ( ret )
    {
		printf( "No\n" );
		exit( 5 );
    }

    ret = sea( env, SQL_ATTR_ODBC_VERSION, (SQLPOINTER) SQL_OV_ODBC3, 0, 0 );
    if ( ret )
    {
		printf( "No\n" );
		exit( 6 );
    }

    ret = pae( SQL_HANDLE_DBC, env, &dbc );
    if ( ret )
    {
		printf( "No\n" );
		exit( 7 );
    }

	printf( "Yes\n" );

	return ( 0 );
}
